const ADOBE_ORG_ID = '05FF6243578784B37F000101@AdobeOrg'
const TRACKING_SERVER = {
  trackingServer: 'schibstedspain.d3.sc.omtrdc.net',
  trackingServerSecure: 'schibstedspain.d3.sc.omtrdc.net'
}

const getAdobeMCVisitorID = function() {
  const demdex = window.Visitor.getInstance(ADOBE_ORG_ID, TRACKING_SERVER)
  return new Promise(function(resolve, reject) {
    if (demdex.getMarketingCloudVisitorID()) {
      const mcvid = demdex.getMarketingCloudVisitorID()
      return resolve(mcvid)
    }
    function retry(retries) {
      if (retries === 0) {
        return resolve('')
      } else {
        if (demdex.getMarketingCloudVisitorID()) {
          const mcvid = demdex.getMarketingCloudVisitorID()
          return resolve(mcvid)
        } else {
          window.setTimeout(function() {
            retry(--retries)
          }, 25)
        }
      }
    }
    retry(80)
  })
}

export default getAdobeMCVisitorID
