import getAdobeMCVisitorId from './getAdobeMCVisitorID'

export default {
  identify: (...args) => {
    return new Promise((resolve, reject) => {
      window.analytics.identify(...args)
      resolve()
    })
  },
  reset: (...args) => {
    return new Promise((resolve, reject) => {
      window.analytics.reset(...args)
      resolve()
    })
  },
  track: (...args) => {
    return new Promise((resolve, reject) => {
      window.analytics.ready(async function() {
        const [event, properties, trackingOptions = {}, fn] = args
        const options = {
          ...trackingOptions,
          traits: {
            ...trackingOptions.traits,
            anonymousId: window.analytics.user().anonymousId(),
            userId: window.analytics.user().id()
          }
        }

        if (window && window.Visitor) {
          const mcvid = await getAdobeMCVisitorId()
          options.integrations = {
            ...trackingOptions.integrations,
            'Adobe Analytics': {
              marketingCloudVisitorId: mcvid
            }
          }
        }
        window.analytics.track(event, properties, options, fn)
        resolve()
      })
    })
  }
}
